///////////////////////////////////////////////////////////////////////////////
//Mit diesem Sketch lassen sich elliptische Fixpunkte auf der Senkrechten x = PI
//finden. Es werden auch unpassende Werte gefunden, beispielsweise für Ordnung 21
//werden y-Werte für Ordnung 3 oder Ordnung 7 ebenfalls gefunden.
//////////////////////////////////////////////////////////////////////////////
double xU = 0; double xO = 2*PI;
double yU = 0 ; double yO = 2*PI;
double schrittWeite;//Je kleiner die Schrittweite, desto länger die Rechenzeit!
double  xUNeu, xONeu, yUNeu, yONeu,xAlt, yAlt, xNeu, yNeu;
double  xH, yH; 
double abstand;//Abstand von Punkt und Bildpunkt bei Fixpunktsuche
double Min ;//Speicher für das Minimum der Abstände von Punkt und Bildpunkt
double x0,y0,x1,y1;//für die Bestimmung der Fixpunkte
double untereGrenze,uG ,obereGrenze ;//eingeschränkter Suchbereich
int ordnung;//Fixpunkt der Ordnung "ordnung" gesucht
double K;//Störungsparameter

//////////////////////////////////////////////////////////////////
void setup(){ 
   size(350,250);
   background(0);
   stroke(255);
   textSize(16);
   K = 0.971635; 
   abstand =0; 
   untereGrenze = 2.4;
   uG= untereGrenze;//Zur späteren Dokumentation
   obereGrenze =  2.6;
   ordnung =21;
   schrittWeite = 0.00000001;//nötigenfalls verkleinern!
   fixpunktIterieren(untereGrenze,obereGrenze,ordnung);
}
///////////////////////////////////////////////////////////////
void fixpunktIterieren(double uG, double oG, int ord){
   println("Start");   
   untereGrenze = uG;
   obereGrenze = oG;
   ordnung = ord;
   Min = 1;
   int i =0;
    while(untereGrenze < obereGrenze){   
        xAlt = PI;
        yAlt = untereGrenze;
        xH = xAlt; //merken, um Abstand zu berechnen
        yH = yAlt;
        while(i < ordnung){      
         yNeu = yAlt + K*Math.sin(xAlt); 
         xNeu = (xAlt + yNeu) % (2*Math.PI);
         xAlt = xNeu;
         yAlt = yNeu;  
         i++; 
     }
     i=0;
     abstand = Math.sqrt((xAlt-xH)*(xAlt-xH)+(yAlt-yH)*(yAlt-yH));
     if(abstand < Min) {
       
         if(abstand< 1.E-6 ){
           if(abstand < Min){
             Min = abstand;
             println(yAlt, Min);
           }
         }
     }    
      Min = 10;
     untereGrenze = untereGrenze + schrittWeite;
    } 
    text("elliptischer Fixpunkt", 20, 20);
    text("K = "+K, 20, 70);
    text("x = "+PI,20, 100);
    text("Odnung: "+ordnung,20, 130);
    text("Schrittweite: "+ schrittWeite,20, 160);
    text("untere Grenze "+ uG,20, 190);
    text("obere Grenze: "+ obereGrenze,20, 220);
}
